﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.Data.Xml.Dom;
using Windows.UI.Notifications;

namespace VSMUpdateLiveTilesDemo.Common
{
    public class LiveTile
    {
        public TileTemplateType WideTileType { get; set; }
        public TileTemplateType SquareTileType { get; set; }
        public string Text { get; set; }
        public string ImageSource { get; set; }

        public LiveTile(TileTemplateType wideTemplate, TileTemplateType squareTemplate)
        {
            WideTileType = wideTemplate;
            SquareTileType = squareTemplate;
        }

        public void Update()
        {
            XmlDocument wideTile = TileUpdateManager.GetTemplateContent(WideTileType);
            SetTextAndImage(wideTile);
            XmlDocument squareTile = TileUpdateManager.GetTemplateContent(SquareTileType);
            SetTextAndImage(squareTile);
            IXmlNode visual = wideTile.ImportNode(squareTile.GetElementsByTagName("binding").Item(0), true);
            wideTile.GetElementsByTagName("visual").Item(0).AppendChild(visual);
            TileNotification tile = new TileNotification(wideTile);
            TileUpdateManager.CreateTileUpdaterForApplication().Update(tile);
        }

        private void SetTextAndImage(XmlDocument tileXml)
        {
            XmlNodeList text = tileXml.GetElementsByTagName("text");
            text.Item(0).AppendChild(tileXml.CreateTextNode(Text));
            XmlNodeList images = tileXml.GetElementsByTagName("image");
            XmlElement image = (XmlElement)images.Item(0);
            if (image != null && !String.IsNullOrWhiteSpace(ImageSource))
            {
                image.SetAttribute("src", ImageSource);
            }
        }
    }
}
